      ** TNAPIFUNC
      ** TNAPI functions

     H nomain
     H Option(*SRCSTMT:*NODEBUGIO)
     H Debug(*YES)
     H DatFmt(*ISO)
     H TimFmt(*ISO)
     H FixNbr(*Zoned: *InputPacked)
     H BNDDIR('QC2LE')

      * Data returned from TNAPI call
     D ReturnData      ds
     D  Connected                      n
     D  ScreenData                 1920
     D  RowDta                       80    dim(24) overlay(ScreenData)
     D  ScreenAttr                 1920
     D  CurrentRow                    2s 0
     D  CurrentCol                    2s 0
     D  ScreenError                  80

     D LogFile         s             10
     D Timeout         s              5  1
     D LoggingOn       s               n

     D SendData        pr
     D  SendBuff                    256    const
     D  FuncKey                       6    const options( *nopass )

     D SendToLoc       pr
     D  Row                           2  0 const
     D  Col                           2  0 const
     D  SendBuff                    256    const
     D  FuncKey                       6    const options(*nopass)

     D TNAPIUser       ds                  dtaara('TNAPIUSER')
     D  TNUser                       10
     D  PW                            2    dim(5)

      * --------------------------------------------------------------------

      // Connect to AS400 and log on

     P LogOn           B                   export
     D  Logon          PI              *
     D  UserID                       10    const
     D  PassWord                     10    const
     D  ParmLogFile                  10    const
     D  ParmTimeOut                   3  0 const options(*nopass)

     D LogonStr        s             40
     D WUser           s             10
     D WPassWord       s             10

      /free
       clear ReturnData;
       if %parms() = 4;
         TimeOut = ParmTimeOut;
       else;
         Timeout = 0;
       endif;
       if TimeOut < 1;
         TimeOut = 30;
       endif;
       LogFile = ParmLogFile;

       // If already connected, end the connection
       If connected;
         SendData(' ':'EOJ');
       endif;

       // Get obfuscated password from data area
       if Userid = '*TNAPIUSER';
         in TnapiUser;
       // Password is obfuscated by shuffling sets of 2 bytes
       // Encrypt series 4,1,3,2,5
       // Decrypt series 2,4,3,1,5
         WPassword = %trim(pw(2)) + %trim(PW(4)) + %trim(PW(3)) +
          %trim(PW(1)) + PW(5);
         WUser = TNUser;
       else;
         WUser = Userid;
         WPassWord = PassWord;
       endif;
       LogonStr = WUser + '%L0' + WPassword + '%L1';
       loggingon = *on;
       SendData(LogonStr:'ENTER');
       loggingon = *off;
       return %addr(ReturnData);

      /end-free
     P                 E

      * --------------------------------------------------------------------

       // Send data and/or a function key
     P SendData        B                   export
     D  SendData       PI
     D  SendBuff                    256    const
     D  ParmKey                       6    const options( *nopass )

     D TNAPI           pr                  extpgm('TNAPI')
     D  SendBuff                    256    const
     D  FuncKey                       6    const
     D  TimeOut                       5  1
     D  WaitStr                     740
     D  System                       64    const
     D  DispScreen                    1    const
     D  ReturnAttr                    1    const
     D  LogFile                      10    const
     D  WaitPtr                       2  0
     D  ReturnCode                    1
     D  ScreenChar                 1920
     D  ScreenAttr                 1920
     D  Row                           2  0
     D  Col                           2  0

     D WaitStr         S            740
     D System          S             64
     D DispScreen      S              1
     D WaitString      s            740
     D ReturnAttr      S              1
     D WaitPtr         S              2  0
     D Buffer          s            256
     D returnCode      s              1
     D FuncKey         s              6
     D Row             s              2  0
     D Col             s              2  0
     D Divisor         s              3  0 inz(0)
     D Dividend        s              3  0
     D DivResult       s              3  0

     D SendMsg         pr                  extpgm('QMHSNDPM')
     D  Msgid                         7    const
     D  MsgFile                      20    const
     D  MsgDta                    32767    const options(*varsize)
     D  DtaLen                       10i 0 const
     D  MsgType                      10    const
     D  MsgQ                         10    const
     D  MsgQNbr                      10i 0 const
     D  MsgKey                        4
     D  Error                      1000

     D MsgKey          s              4
     D ErrorDS         s           1000
     D Errortext       s             40    inz('Unexpected screen error')

      /free
       ScreenError = *blanks;
       Buffer = SendBuff;
       if %parms() = 1;
         if Buffer = *blanks;
           return;
         endif;
         FuncKey = *blanks;
       else;
         FuncKey = ParmKey;
       endif;

       // If not already connected, don't call TNAPI unless
       // we are logging on
       if not connected and not loggingon;
         return;
       endif;

       // Call TNAPI
       TNAPI(Buffer:FuncKey:TimeOut:WaitStr:'127.0.0.1':'Y':'Y':
        LogFile:WaitPtr:ReturnCode:ScreenData:ScreenAttr:Row:Col);
       Connected = *on;

       // Bell character
       // Send RESET key and continue
       if ReturnCode = '1';
         ScreenError = GetScrnDta(24:1:80);
         TNAPI(' ':'RESET':TimeOut:WaitStr:'127.0.0.1':'Y':'Y':
          LogFile:WaitPtr:ReturnCode:ScreenData:ScreenAttr:Row:Col);
         Returncode = '0';
       endif;

       // Unknown screen error occurred
       if ReturnCode <> '0';
         Connected = *off;
         if FuncKey <> 'EOJ';
       // Generate error to be monitored by main program
           if ScreenError = *blanks;
             ScreenError = ErrorText;
           endif;
           dump;
           SendMsg('CPF9898':'QCPFMSG   *LIBL':ErrorText:
            %size(ErrorText):'*ESCAPE':'*':0:MsgKey:ErrorDS);
         endif;
       endif;

       // Save current location
       CurrentRow = Row;
       CurrentCol = Col;

       return;
      /end-free
     P                 E

      * --------------------------------------------------------------------

      // Send a string of specified length with optional location
      //  and terminating string (%FE = field exit, etc)
      //  %CR is used to send blanks at the end of the string
     P SendStr         B                   export
     D  SendStr        PI
     D  SendBuff                    256    const
     D  SendLen                       2  0 const
     D  Row                           2  0 const options(*nopass)
     D  Col                           2  0 const options(*nopass)
     D  FieldTerm                     3    const options(*nopass)

     D Buffer          s            256
      /free

       if %parms> 4;
         buffer = %subst(SendBuff:1:SendLen) + FieldTerm;
       else;
         buffer = %subst(SendBuff:1:SendLen) + '%CR';
       endif;
       if %parms > 2;
         SendToLoc(Row:col:Buffer);
       else;
         SendData(SendBuff);
       endif;

      /end-free

     P                 E
      * --------------------------------------------------------------------

       // Send a string to a specifed position on the screen
     P SendToLoc       B                   export
     D  SendToLoc      PI
     D  Row                           2  0 const
     D  Col                           2  0 const
     D  SendBuff                    256    const
     D  FuncKey                       6    const options(*nopass)

     D SendStr         s            256
     D SendFunc        s              6
      /free

       if %parms = 4;
         SendFUnc = Funckey;
       else;
         SendFunc = *blanks;
       endif;

       if row <> CurrentRow or col <> CurrentCol;
         SendStr = '%PC' + %editc(Row:'X') + ',' + %editc(col:'X');
       endif;

       SendStr = %trim(SendStr) + SendBuff;
       SendData(SendStr:SendFunc);
       return;
      /end-free

     P                 E

      * --------------------------------------------------------------------

      // Send a string end the ENTER key
     P SendScrn        B                   export
     D  SendScrn       PI
     D  SendBuff                    256    const

      /free
       if SendBuff <> *blanks;
         SendData(SendBuff:'ENTER');
       endif;
      /end-free
     P                 E
      * --------------------------------------------------------------------

      // Send a function key
     P SendKey         B                   export
     D  SendKey        PI
     D  FuncKey                       6    const

      /free
       if FuncKey <> *blanks;
         SendData(' ':FuncKey);
       endif;
       return;
      /end-free
     P                 E
      * --------------------------------------------------------------------
      // Send ATTN key and wait for command entry screen to appear
     P SendATTNKey     B                   export
     D  SendATTNKey    PI

     D sleep           PR            10U 0 ExtProc('usleep')
     D  microSecs                    10U 0 value

     D QuarterSecond   s             10u 0 inz(250000)
     D n               s              5i 0
     D F9Sent          s               n
     D teststr         s              7

      /free
       SendData(' ':'ATTN');
       for n = 1 to 20;
         teststr = %subst(RowDta(19):37:7);
         if teststr = 'Command';
           leave;
         endif;
         teststr = %subst(RowDta(1):34:7);
         if teststr = 'Command';
           leave;
         endif;
         if %subst(RowDta(1):26:11) = 'Operational';
           If not F9Sent;
             SendData(' ':'F9');
             F9Sent = *on;
             iter;
           endif;
         endif;
         Sleep(QuarterSecond);
         SendData(' ':'REDRAW');
       endfor;
       return;
      /end-free
     P                 E
      * --------------------------------------------------------------------

      // Position cursor to a specified row and column
     P PosCsr          B                   export
     D  PosCsr         PI
     D  PosRow                        2  0 const
     D  PosCol                        2  0 const

     D CsrStr          s              5
     D
      /free
       CsrStr = %editc(PosRow:'X') + ',' + %editc(PosCol:'X');
       SendData(CsrStr:'POSCSR');
       return;
      /end-free
     P                 E
      * --------------------------------------------------------------------

      // Get screen data from a specified location
     P GetScrnDta      B                   export
     D  GetScrnDta     PI            80
     D  Row                           2  0 const
     D  Col                           2  0 const
     D  Len                           2  0 const

     D endpos          s              3  0

      /free
       if row > 0 and row < 25 and
          col > 0 and col < 81;
         endpos = col + len - 1;
         if endpos < 81;
           return %subst(rowdta(row):col:len);
         endif;
       endif;

       return ' ';

      /free
     P                 E
